﻿@model PaymentViewModel
@{

    string title = Model.UserSubscriptionID != 0 ? "پرداخت هزینه اشتراک ماهیانه" : (Model.UserContractID != 0 ? "پرداخت هزینه و دریافت فایل قرارداد" : "پرداخت هزینه مشاوره");
    ViewData["Title"] = title;
    Layout = "~/Views/Shared/_Layout.cshtml";
    int id_userContract = Model.UserContractID != null ? Model.UserContractID.GetValueOrDefault() + 1584 : 0;
}

<div class="container-fluid" style="background: #e9ecef;padding:20px;">
    <div class="container">

        <div class="Paycard text-right  @(Model.IsSuccessful ? "success row" : "failed row")" data-aos="fade-up" data-aos-delay="300">
            <form method="post"></form>
            <div class="col-md-6 col-sm-12">

                <h2 data-aos="zoom-in" data-aos-delay="1000" class="aos-init aos-animate @(!Model.IsSuccessful ? "Faild" : "")">

                    @{
                        if (Model.IsSuccessful)
                        {
                            <span>پرداخت با موفقیت انجام شد. <i class='fa fa-smile-o'></i></span>
                        }
                        else
                        {
                            <span>پرداخت ناموفق<i class='fa fa-frown-o'></i></span>
                            @if (ViewData["error"] != null)
                            {
                                Exception error = ViewData["error"] as Exception;
                                <br />
                                <span style="font-size: 14px;font-weight: 100;">
                                    @(error.Message=="Exception of type 'System.Exception' was thrown." ? "موردی یافت نشد" : error.Message)
                                </span>
                            }
                        }
                    }

                </h2>
                @if (Model.PaymentID != null)
                {
                    <div class="list-Info" data-aos="zoom-in" data-aos-delay="500">
                        <h3> @Model.Title</h3>
                    </div>

                    <div class="list-Info" data-aos="fade-up" data-aos-delay="600">
                        <span>شناسه پرداخت : </span>
                        <span> @Model.PaymentID </span>
                    </div>

                    <div class="list-Info" data-aos="fade-up" data-aos-delay="800">
                        <span>تاریخ : </span>
                        <span>@Model.Time</span>
                    </div>

                    <div class="list-Info" data-aos="fade-up" data-aos-delay="1000">
                        <span>مبلغ : </span>
                        <span> @string.Format("{0:n0}", Convert.ToInt32(Model.Amount)) تومان</span>
                    </div>

                    @if (!Model.IsSuccessful)
                    {
                        <button class="btn btn-success" data-aos="zoom-in" data-aos-delay="1200" onclick="Payment(@Model.UserContractID , 'pod')">پرداخت از طریق پادیوم</button>
                        <button class="btn btn-success" data-aos="zoom-in" data-aos-delay="1200" onclick="Payment(@Model.UserContractID , 'zarinpal')">پرداخت از طریق زرین پال</button>
                    }
                }


            </div>
            <div class="col-md-6 col-sm-12">
                @if (Model.IsSuccessful)
                {
                    @if (!string.IsNullOrEmpty(Model.ConsultationOrderID))
                    {
                        <ul>
                            <li>کاربر گرامی وقت مشاوره مورد نظر در سیستم ثبت شد.</li>
                            <li>  در صورت داشتن هر گونه سوال ، از طریق <span>  چت آنلاین  </span> و یا <span>  شماره تماس  </span>  با ما در ارتباط باشید . </li>
                        </ul>

                    }
                    else if (Model.UserContractID != 0 && Model.UserContractID != null)
                    {
                        if (Model.Type == 0)
                        {
                            <ul>
                                <li>   در صورت نیاز به ویرایش فایل PDF به بخش  <span> قراردادها </span>  در <span> پروفایل کاربری </span> رجوع کنید . </li>
                                <li>ویرایش فایل PDF تا  <span> 2 </span> بار برای شما امکان پذیر است .</li>
                                <li> نسخه های  قرارداد در قسمت  <span>قراردادها </span>  برای شما موجود خواهد بود   .</li>
                                <li>  در صورت داشتن هر گونه سوال ، از طریق <span>  چت آنلاین  </span> و یا <span>  شماره تماس  </span>  با ما در ارتباط باشید . </li>
                            </ul>
                            <div class="row">
                                <div class="col-md-6 col-sm-12 padding-right-0">
                                    <button data-aos="zoom-in" data-aos-delay="1200" id="PDF-download" class="btn btn-success" onclick="ContractDownload(@Model.UserContractID)"></button>
                                </div>
                                <div class="col-md-6 col-sm-12 padding-left-0 text-left">
                                    <button data-aos="zoom-in" data-aos-delay="1200" id="Word-download" class="btn btn-success" onclick="WordDownload(@Model.UserContractID)"></button>
                                </div>
                                <div class="Image-Holder">
                                    <img src="/Images/Loader/ajax-loader.gif">
                                    <span> لطفا شکیبا باشید  ... </span>
                                </div>
                            </div>
                        }
                        else
                        {

                            <div class="col-md-6 col-sm-12 padding-left-0 text-left">
                                <form method="post">
                                    <button data-aos="zoom-in" data-aos-delay="1200" id="Word-download" class="btn btn-success" onclick="GetWord(@id_userContract)"></button>
                                </form>

                            </div>
                            <div class="Image-Holder">
                                <img src="/Images/Loader/ajax-loader.gif">
                                <span> لطفا شکیبا باشید  ... </span>
                            </div>
                        }

                    }
                    else if (Model.UserSubscriptionID != 0 && Model.UserSubscriptionID != null)
                    {

                        <ul>
                            <li>کاربر گرامی اشتراک ماهانه از همین حالا برای شما فعال گردید.</li>
                            <li>  در صورت داشتن هر گونه سوال ، از طریق <span>  چت آنلاین  </span> و یا <span>  شماره تماس  </span>  با ما در ارتباط باشید . </li>
                        </ul>
                    }

                }
                else
                {
                    <p id="profileInfo">
                        @if (!string.IsNullOrEmpty(Model.ConsultationOrderID))
                        {
                            <text>  اطلاعات مورد نیاز جهت ' درخواست مشاوره ' در پروفایل کاربری شما ذخیره شده است . در صورت تمایل  می توانید از پروفایل کاربری خود اقدام به درخواست خود نمائید.</Text>

                        }
                        else if (Model.UserContractID != 0 && Model.UserContractID != null)
                        {
                            <text>  اطلاعات مورد نیاز  جهت دریافت فایل قرارداد در پروفایل کاربری شما ذخیره شده است . در صورت تمایل  می توانید از پروفایل کاربری خود اقدام به دریافت فایل قرارداد نمائید.</Text>
                        }
                        else if (Model.UserSubscriptionID != 0 && Model.UserSubscriptionID != null)
                        {
                            <text>  اطلاعات مورد نیاز  جهت دریافت اشتراک ماهیانه در پروفایل کاربری شما ذخیره شده است در صورت تمایل  می توانید از پروفایل کاربری خود اقدام به تهیه اشتراک ماهانه نمائید .</Text>
                        }
                    </p>
                }
            </div>
        </div>
    </div>
</div>



@*#########################   Temperory Wrapper for runtime pdf Content  ###################################*@
<div id="temperory-wrapper" style="display:none;"></div>

@section Scripts{

    <script>

        var Address;
        if (window.location.href.includes("localhost")) Address = "https://localhost:5001/";
        else Address = "https://lawmingo.com/";

        function ContractDownload(id) {

            $(".Image-Holder").show();
            $.ajax({

                url: '/Contract/ArticleDetails',
                type: 'POST',
                dataType: 'json',
                headers:
                {
                    "RequestVerificationToken": $('.Paycard form input:hidden[name="__RequestVerificationToken"]').val()
                },
                data: {
                    UserContractID: id
                },
                success: function (data) {

                    console.log(data)
                    //create Article Content with Data
                    var content = "<form style='padding:0;margin:0;' id='contract'><div style='text-align:center;margin:0;margin-bottom:35px;'><p style='font-weight:bold;text-align:center;font-size:26px;margin:0 auto !important;'>" + data.ContractName + "</p></div>";

                    //content += "<h6 style='font-weight:bold;margin-bottom:40px;text-align:center;>" + data.ContractName  + "<h6>";

                    for (var i = 0, len = data.Art.length; i < len; ++i) {

                        content += "<p style='font-weight:bold;margin-bottom:20px;color:#6e1529'> ماده " + Number(data.Art[i].Article.split('-')[0]) + " - " + data.Art[i].Article.split('-')[1] + "<p>";
                        slicePluse = '';
                        var counter = 0;
                        for (var ii = 0; ii < data.Art[i].Content.length; ii++) {

                            if (data.Art[i].Content.length > 1) {

                                var con = data.Art[i].Content[ii];
                                con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ").replace("placeholder", " ");

                                var count = (con.match(/===/g) || []).length;
                                var SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                //console.log("count : ", count)
                                //console.log("SliceCount : ", SliceCount)

                                if (count !== null && count >= 1) {

                                    var slice = con.split('===');

                                    for (var iii = 0; iii < slice.length; iii++) {

                                        if (!isEmpty(slice[iii]) && !slice[iii].startsWith('<p dir="RTL"')) {
                                            //if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; " && slice[iii] !== '<p dir="RTL" data-list="0" data-level="1">' && slice[iii] !== '<p>' && slice[iii] !=='<p dir="RTL" data-list="0" data-level="2">') {

                                            SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                            counter++;

                                            var row = '';
                                            row += "<p row>";
                                            row += data.Art[i].Article.split('-')[0];
                                            row += " - ";
                                            row += ii < 1 ? counter : SliceCount + 1;
                                            row += " ";
                                            row += slice[iii];
                                            row += " </p> ";

                                            slicePluse += row;
                                        }
                                    }

                                }
                                else {

                                    row = '';
                                    row += "<p row>";
                                    row += data.Art[i].Article.split('-')[0];
                                    row += " - ";
                                    row += ii < 1 ? 1 : SliceCount + 1;
                                    row += " ";
                                    row += con;
                                    row += " </p> ";

                                    slicePluse += row;
                                }

                            }
                            else {
                                con = data.Art[i].Content[ii];
                                con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ");

                                count = (con.match(/===/g) || []).length;
                                SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                if (count !== null && count >= 1) {
                                    slice = con.split('===');

                                    for (iii = 0; iii < slice.length; iii++) {

                                        if (!isEmpty(slice[iii]) && !slice[iii].startsWith('<p dir="RTL"')) {
                                            //if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; " && slice[iii] !== '<p dir="RTL" data-list="0" data-level="1">' && slice[iii] !== '<p>'  && slice[iii] !=='<p dir="RTL" data-list="0" data-level="2">') {
                                            counter++;

                                            row = '';
                                            row += "<p row>";
                                            row += data.Art[i].Article.split('-')[0];
                                            row += " - ";
                                            row += counter;
                                            row += " ";
                                            row += slice[iii];
                                            row += " </p> ";

                                            slicePluse += row;
                                        }
                                    }

                                }
                                else {
                                    slicePluse += "<p>" + con + "</p>";
                                }
                            }
                        }

                        content += slicePluse;
                    }

                    content += "</form>";

                    content = content.replace(/ {1,}/g, " ");
                    content = content.replace(/placeholder/g, " ");

                    $("#temperory-wrapper").html(content);


                    //bind properties to Artice Content
                    data.Props.forEach(function (value, index) {

                        var selector = "#temperory-wrapper input[id$='" + "-" + value.ArticlePropertyID + "']";
                        $(selector).replaceWith("<span style='padding-left:10px;'>" + value.Value + "</span>");
                    });


                    //check if paragraph is empty deleted paragraph
                    $('#temperory-wrapper p').each(function () {
                        var $this = $(this);
                        if ($this.html().replace(/\s|&nbsp;/g, '').length === 0)
                            $this.remove();
                    });

                    //if (user_Answer !== null) {
                    //    var currentHref = window.location.href.split("/");
                    //    getPreviousUserContractId = currentHref[currentHref.length - 1];
                    //}

                    $.ajax({
                        url: '/ExportPdf/CreatePdfAsync',
                        type: 'POST',
                        data: {
                            Contract: $("#temperory-wrapper").html(),
                            userContractID: id,
                            //PreviousUserContractID: user_Answer !== null ? getPreviousUserContractId : 0
                        },
                        dataType: 'json',
                        success: function (res) {

                        }
                    }).always(function (fileName) {

                        $("#temperory-wrapper").html(" ");


                        $("#PDF-download").replaceWith("<a id='PDF-download' class='btn btn-success' href='" + Address + "Uploads/PdfFiles/" + fileName.responseText.split("*")[1] + "/" + fileName.responseText.split("*")[0] + "'" + "class='btn btn-success-custom'><i style='vertical-align: middle;' class='fa fa-download'></i></a>");

                        $(".Image-Holder").hide();
                        //sessionStorage.clear();

                    });
                }
            });

        }

        function WordDownload(id) {
            $(".Image-Holder").show();
            $.ajax({

                url: '/Contract/ArticleDetails',
                type: 'POST',
                dataType: 'json',
                data: {
                    UserContractID: id
                },
                headers:
                {
                    "RequestVerificationToken": $('.Paycard form input:hidden[name="__RequestVerificationToken"]').val()
                },
                success: function (data) {

                    console.log(data)
                    //create Article Content with Data
                    var content = "<form style='padding:15px;' id='contract'><div style='text-align:center;margin-bottom:80px;'><p style='font-weight:bold;text-align:center;font-size:26px;margin:0 auto !important;'>" + data.ContractName + "</p></div>";

                    //content += "<h6 style='font-weight:bold;margin-bottom:40px;text-align:center;>" + data.ContractName  + "<h6>";

                    for (var i = 0, len = data.Art.length; i < len; ++i) {

                        content += "<p style='font-weight:bold;margin-bottom:20px;color:#6e1529'> ماده " + Number(data.Art[i].Article.split('-')[0]) + " - " + data.Art[i].Article.split('-')[1] + "<p>";
                        slicePluse = '';
                        var counter = 0;
                        for (var ii = 0; ii < data.Art[i].Content.length; ii++) {

                            if (data.Art[i].Content.length > 1) {

                                var con = data.Art[i].Content[ii];
                                con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ").replace("placeholder", " ");

                                var count = (con.match(/===/g) || []).length;
                                var SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                //console.log("count : ", count)
                                //console.log("SliceCount : ", SliceCount)

                                if (count !== null && count >= 1) {

                                    var slice = con.split('===');

                                    for (var iii = 0; iii < slice.length; iii++) {

                                        if (!isEmpty(slice[iii]) && !slice[iii].startsWith('<p dir="RTL"')) {
                                            //if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; " && slice[iii] !== '<p dir="RTL" data-list="0" data-level="1">' && slice[iii] !== '<p>' && slice[iii] !=='<p dir="RTL" data-list="0" data-level="2">') {

                                            SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                            counter++;

                                            var row = '';
                                            row += "<p row>";
                                            row += data.Art[i].Article.split('-')[0];
                                            row += " - ";
                                            row += ii < 1 ? counter : SliceCount + 1;
                                            row += " ";
                                            row += slice[iii];
                                            row += " </p> ";

                                            slicePluse += row;
                                        }
                                    }

                                }
                                else {

                                    row = '';
                                    row += "<p row>";
                                    row += data.Art[i].Article.split('-')[0];
                                    row += " - ";
                                    row += ii < 1 ? 1 : SliceCount + 1;
                                    row += " ";
                                    row += con;
                                    row += " </p> ";

                                    slicePluse += row;
                                }

                            }
                            else {
                                con = data.Art[i].Content[ii];
                                con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ");

                                count = (con.match(/===/g) || []).length;
                                SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                if (count !== null && count >= 1) {
                                    slice = con.split('===');

                                    for (iii = 0; iii < slice.length; iii++) {

                                        if (!isEmpty(slice[iii]) && !slice[iii].startsWith('<p dir="RTL"')) {
                                            //if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; " && slice[iii] !== '<p dir="RTL" data-list="0" data-level="1">' && slice[iii] !== '<p>'  && slice[iii] !=='<p dir="RTL" data-list="0" data-level="2">') {
                                            counter++;

                                            row = '';
                                            row += "<p row>";
                                            row += data.Art[i].Article.split('-')[0];
                                            row += " - ";
                                            row += counter;
                                            row += " ";
                                            row += slice[iii];
                                            row += " </p> ";

                                            slicePluse += row;
                                        }
                                    }

                                }
                                else {
                                    slicePluse += "<p>" + con + "</p>";
                                }
                            }
                        }

                        content += slicePluse;
                    }

                    content += "</form>";

                    content = content.replace(/ {1,}/g, " ");
                    content = content.replace(/placeholder/g, " ");

                    $("#temperory-wrapper").html(content);


                    //bind properties to Artice Content
                    data.Props.forEach(function (value, index) {

                        var selector = "#temperory-wrapper input[id$='" + "-" + value.ArticlePropertyID + "']";
                        $(selector).replaceWith("<span style='padding-left:10px;'>" + value.Value + "</span>");
                    });


                    //check if paragraph is empty deleted paragraph
                    $('#temperory-wrapper p').each(function () {
                        var $this = $(this);
                        if ($this.html().replace(/\s|&nbsp;/g, '').length === 0)
                            $this.remove();
                    });

                    //if (user_Answer !== null) {
                    //    var currentHref = window.location.href.split("/");
                    //    getPreviousUserContractId = currentHref[currentHref.length - 1];
                    //}

                    $.ajax({
                        url: '/ExportWord/CreateWordAsync',
                        type: 'POST',
                        data: {
                            Contract: $("#temperory-wrapper").html(),
                            userContractID: id,
                            //PreviousUserContractID: user_Answer !== null ? getPreviousUserContractId : 0
                        },
                        dataType: 'json',
                        success: function (res) {

                        }
                    }).always(function (fileName) {

                        $("#temperory-wrapper").html(" ");
                        $("#Word-download").replaceWith("<a id='Word-download' class='btn btn-success' href='" + Address + "Uploads/WordFiles/" + fileName.responseText.split("*")[1] + "/" + fileName.responseText.split("*")[0] + "'" + "> <i style='vertical-align: middle;' class='fa fa-download'></i></a>");

                        $(".Image-Holder").hide();
                        //sessionStorage.clear();

                    });
                }
            });
        }

        function isEmpty(str) {
            return (!str || 0 === str.length || /^\s*$/.test(str) || str.trim() === "");
        }

        function GetWord(id) {

            $.ajax({
                method: 'POST',
                url: '/Contract/WordFile',
                headers: { "RequestVerificationToken": $('.Paycard form input:hidden[name="__RequestVerificationToken"]').val() },
                xhrFields: { responseType: "blob" },
                data: { UserContractID: id },
                success: function (data) {
                    console.log(data)
                    var blob = new Blob([data], { type: "application/vnd.openxmlformats-officedocument.wordprocessingml.document" })
                    var url = window.URL.createObjectURL(blob);
                    var a = document.createElement("a");                 
                    document.body.appendChild(a);
                    a.download = "Contract.docx";
                    a.href = url;
                    a.style.display = 'none';
                    a.click();
                }
            });
        }

    </script>
}